-- Test edit_collection
set client_min_messages to warning;
create extension if not exists pgtap;
reset client_min_messages;

begin;

select plan(17);

set search_path to numerus, public;

select has_function('numerus', 'edit_collection', array['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]']);
select function_lang_is('numerus', 'edit_collection', array['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]'], 'plpgsql');
select function_returns('numerus', 'edit_collection', array['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]'], 'uuid');
select isnt_definer('numerus', 'edit_collection', array['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]']);
select volatility_is('numerus', 'edit_collection', array['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]'], 'volatile');

select function_privs_are('numerus', 'edit_collection', array ['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]'], 'guest', array []::text[]);
select function_privs_are('numerus', 'edit_collection', array ['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]'], 'invoicer', array ['EXECUTE']);
select function_privs_are('numerus', 'edit_collection', array ['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]'], 'admin', array ['EXECUTE']);
select function_privs_are('numerus', 'edit_collection', array ['uuid', 'date', 'integer', 'text', 'text', 'tag_name[]'], 'authenticator', array []::text[]);


set client_min_messages to warning;
truncate invoice_collection cascade;
truncate collection cascade;
truncate invoice_product_tax cascade;
truncate invoice_product cascade;
truncate invoice cascade;
truncate contact_tax_details cascade;
truncate contact cascade;
truncate tax cascade;
truncate tax_class cascade;
truncate payment_account cascade;
truncate payment_method cascade;
truncate company cascade;
reset client_min_messages;


set constraints "company_default_payment_method_id_fkey" deferred;

insert into company (company_id, business_name, vatin, trade_name, phone, email, web, address, city, province, postal_code, country_code, currency_code, default_payment_method_id)
values (1, 'Company 2', 'XX123', '', '555-555-555', 'a@a', '', '', '', '', '', 'ES', 'EUR', 111)
;

insert into payment_method (payment_method_id, company_id, name, instructions)
values (111, 1, 'cash', 'cash')
;

set constraints "company_default_payment_method_id_fkey" immediate;

insert into tax_class (tax_class_id, company_id, name)
values (11, 1, 'tax')
;

insert into tax (tax_id, company_id, tax_class_id, name, rate)
values (2, 1, 11, 'IRPF -15 %', -0.15)
     , (3, 1, 11, 'IVA 4 %', 0.04)
     , (4, 1, 11, 'IVA 10 %', 0.10)
;

insert into contact (contact_id, company_id, name)
values ( 9, 1, 'Customer 1')
;

insert into contact_tax_details (contact_id, business_name, vatin, address, city, province, postal_code, country_code)
values (9, 'Customer 1', 'XX555', '', '', '', '', 'ES')
;


insert into invoice (invoice_id, company_id, invoice_number, contact_id, invoice_date, payment_method_id, currency_code, invoice_status)
values (13, 1, 'INV001', 9, '2011-01-11', 111, 'EUR', 'paid')
     , (14, 1, 'INV002', 9, '2022-02-22', 111, 'EUR', 'paid')
     , (15, 1, 'INV003', 9, '2022-02-22', 111, 'EUR', 'partial')
     , (16, 1, 'REF001', 9, '2023-03-03', 111, 'EUR', 'paid')
     , (17, 1, 'REF002', 9, '2023-03-03', 111, 'EUR', 'paid')
     , (18, 1, 'REF003', 9, '2023-03-03', 111, 'EUR', 'paid')
;

insert into invoice_product (invoice_product_id, invoice_id, name, price)
values (19, 13, 'P1', 111)
     , (20, 14, 'P1', 111)
     , (21, 14, 'P2', 111)
     , (22, 15, 'P2', 111)
     , (23, 15, 'P2', 111)
     , (24, 15, 'P2', 111)
     , (25, 16, 'P1', 10000)
     , (26, 17, 'P1', 10000)
     , (27, 18, 'P1', 10000)
;

insert into invoice_product_tax (invoice_product_id, tax_id, tax_rate)
values (25, 3,  0.04)
     , (26, 2, -0.15)
     , (27, 2, -0.15)
     , (27, 4,  0.10)
;

insert into payment_account (payment_account_id, company_id, payment_account_type, name)
values (11, 1, 'cash', 'Cash 1')
     , (12, 1, 'cash', 'Cash 2')
     , (13, 1, 'other', 'Other')
;

insert into collection (collection_id, company_id, slug, description, collection_date, payment_account_id, amount, currency_code, payment_status, tags)
values (16, 1, '7ac3ae0e-b0c1-4206-a19b-0be20835edd4', 'Payment INV001', '2023-05-04', 12, 111, 'EUR', 'complete', '{tag1}')
     , (17, 1, 'b57b980b-247b-4be4-a0b7-03a7819c53ae', 'First INV002', '2023-05-05', 13, 100, 'EUR', 'partial', '{tag2}')
     , (18, 1, '3bdad7a8-4a1e-4ae0-b5c6-015e51ee0502', 'Second INV002', '2023-05-06', 13, 122, 'EUR', 'partial', '{tag1,tag3}')
     , (19, 1, '5a524bee-8311-4d13-9adf-ef6310b26990', 'Partial INV003', '2023-05-07', 11, 123, 'EUR', 'partial', '{}')
     , (20, 1, '65222c3b-4faa-4be4-b39c-5bd170a943cf', 'Re: REF001', '2023-03-07', 11, 10400, 'EUR', 'complete', '{}')
     , (21, 1, 'dbb699cf-d1f4-40ff-96cb-8f29e238d51d', 'Re: REF002', '2023-03-07', 11, 8500, 'EUR', 'complete', '{}')
     , (22, 1, '0756a50f-2957-4661-abd2-e422a848af4e', 'Re: REF003', '2023-03-07', 11, 9500, 'EUR', 'complete', '{}')
;

insert into invoice_collection (invoice_id, collection_id)
values (13, 16)
     , (14, 17)
     , (14, 18)
     , (15, 19)
     , (16, 20)
     , (17, 21)
     , (18, 22)
;

select lives_ok(
	$$ select edit_collection('7ac3ae0e-b0c1-4206-a19b-0be20835edd4', '2023-05-06', 13, 'Partial INV001', '1.00', array['tag1']) $$,
	'Should be able to change a complete collection to partial'
);

select lives_ok(
	$$ select edit_collection('b57b980b-247b-4be4-a0b7-03a7819c53ae', '2023-05-07', 12, 'First INV002', '0.50', array['tag1', 'tag3']) $$,
	'Should be able to adjust a partial collection, that is still partial, and the invoice now becomes partial'
);

select lives_ok(
	$$ select edit_collection('5a524bee-8311-4d13-9adf-ef6310b26990', '2023-05-01', 11, 'Complete INV003', '3.33', array[]::tag_name[]) $$,
	'Should be able to complete a previously partial collection'
);

select lives_ok(
	$$ select edit_collection('65222c3b-4faa-4be4-b39c-5bd170a943cf', '2023-03-10', 11, 'Re: REF001', '103.99', array[]::tag_name[]) $$,
	'Should be able to make partial a collection with tax.'
);

select lives_ok(
	$$ select edit_collection('dbb699cf-d1f4-40ff-96cb-8f29e238d51d', '2023-03-10', 11, 'Re: REF002', '84.99', array[]::tag_name[]) $$,
	'Should be able to make partial a collection with negative tax.'
);

select lives_ok(
	$$ select edit_collection('0756a50f-2957-4661-abd2-e422a848af4e', '2023-03-10', 11, 'Re: REF003', '94.99', array[]::tag_name[]) $$,
	'Should be able to make partial a collection with multiple taxe.'
);

select bag_eq(
	$$ select description, collection_date::text, payment_account_id, amount, payment_status, tags::text from collection $$,
	$$ values ('Partial INV001', '2023-05-06', 13, 100, 'partial', '{tag1}')
	        , ('First INV002', '2023-05-07', 12, 50, 'partial', '{tag1,tag3}')
	        , ('Second INV002', '2023-05-06', 13, 122, 'partial', '{tag1,tag3}')
	        , ('Complete INV003', '2023-05-01', 11, 333, 'complete', '{}')
	        , ('Re: REF001', '2023-03-10', 11, 10399, 'partial', '{}')
	        , ('Re: REF002', '2023-03-10', 11, 8499, 'partial', '{}')
	        , ('Re: REF003', '2023-03-10', 11, 9499, 'partial', '{}')
	$$,
	'Should have updated all collections'
);

select bag_eq(
	$$ select invoice_id, invoice_status from invoice $$,
	$$ values (13, 'partial')
	        , (14, 'partial')
	        , (15, 'paid')
	        , (16, 'partial')
	        , (17, 'partial')
	        , (18, 'partial')
	$$,
	'Should have updated invoices too'
);

select *
from finish();

rollback;
